##### ----- SETUP ----- ####

### Scoreboard processing
scoreboard players add @s pathfinding 1
scoreboard players set mod_forest pathfinding 16
scoreboard players operation @s pathfinding %= mod_forest pathfinding

### Remove previous Marker
tp @e[type=piki:move_marker,family=marker_forest_trader] ~ 3 ~
event entity @e[type=piki:move_marker,family=marker_forest_trader] instant_despawn



##### ----- MOVE TO CASTLE LOGIC ----- ####

### Move Castle
execute @s[scores={pathfinding=0}] ~ ~ ~ summon piki:move_marker 1 84 159 marker_forest_trader
execute @s[scores={pathfinding=1}] ~ ~ ~ summon piki:move_marker 6 83 127 marker_forest_trader
execute @s[scores={pathfinding=2}] ~ ~ ~ summon piki:move_marker 0 76 72 marker_forest_trader
execute @s[scores={pathfinding=3}] ~ ~ ~ summon piki:move_marker 0 78.8 25 marker_forest_trader



##### ----- GATE LOGIC ----- ####

### Wait at gate
execute @s[scores={pathfinding=4},tag=lowered] ~ ~ ~ tag @s add wait_gate
execute @s[scores={pathfinding=4},tag=lowered] ~ ~ ~ event entity @s wait_gate

### Open gate
execute @s[scores={pathfinding=4},tag=lowered,tag=passcode_known] ~ ~ ~ event entity @e[type=piki:gear,c=1] raise_temp

### Gate already open
execute @s[scores={pathfinding=4},tag=!lowered] ~ ~ ~ scoreboard players add @s pathfinding 1



##### ----- CASTLE LOGIC ----- ####

### Set marker inside castle
execute @s[scores={pathfinding=5}] ~ ~ ~ tag @s remove wait_gate
execute @s[scores={pathfinding=5}] ~ ~ ~ tag @s remove lowered
execute @s[scores={pathfinding=5}] ~ ~ ~ summon piki:move_marker 0 78.8 11 marker_forest_trader

### Wait at castle on regular runs (skip next pathfinding logic (scores=7) for scared Trader)
execute @s[scores={pathfinding=6},tag=!scared] ~ ~ ~ event entity @s wait_castle
execute @s[scores={pathfinding=6},tag=!scared] ~ ~ ~ scoreboard players add @s pathfinding 1

### Wait in castle on first run (Scared - needs to receive Cyber fox to continue)
execute @s[scores={pathfinding=6},tag=scared] ~ ~ ~ summon piki:move_marker -6 78.8 3 marker_forest_trader
execute @s[scores={pathfinding=6},tag=scared] ~ ~ ~ event entity @e[type=piki:koop,tag=lowered] raise

### Setup for scared 
execute @s[scores={pathfinding=7},tag=scared] ~ ~ ~ event entity @s sign_warn
execute @s[scores={pathfinding=7},tag=scared] ~ ~ ~ event entity @s wait_castle_scared

### Leave Castle
execute @s[scores={pathfinding=8},tag=scared] ~ ~ ~ event entity @s sign_clear
execute @s[scores={pathfinding=8},tag=scared] ~ ~ ~ tag @s remove scared
execute @s[scores={pathfinding=8}] ~ ~ ~ summon piki:move_marker 0 78.8 3 marker_forest_trader
execute @s[scores={pathfinding=9}] ~ ~ ~ summon piki:move_marker 0 78.8 22 marker_forest_trader



##### ----- GATE LOGIC ----- ####

### Wait at gate
execute @s[scores={pathfinding=10},tag=lowered] ~ ~ ~ tag @s add wait_gate

### Gate already open
execute @s[scores={pathfinding=10},tag=!lowered] ~ ~ ~ scoreboard players add @s pathfinding 1



##### ----- MOVE TO VILLAGE LOGIC ----- ####

### Move to Village
execute @s[scores={pathfinding=11}] ~ ~ ~ summon piki:move_marker 0 77.8 72 marker_forest_trader
execute @s[scores={pathfinding=12}] ~ ~ ~ summon piki:move_marker 6 84.8 127 marker_forest_trader
execute @s[scores={pathfinding=13}] ~ ~ ~ summon piki:move_marker 1 85.8 159 marker_forest_trader
execute @s[scores={pathfinding=14}] ~ ~ ~ summon piki:move_marker 1 87.8 174 marker_forest_trader

### Wait at Village
execute @s[scores={pathfinding=15}] ~ ~ ~ event entity @s wait_village



##### ----- CLEANUP ----- ####

### Reset pathing increment
event entity @s increment_reset