##### ----- SETUP ----- ####

### Scoreboard processing
scoreboard players add @s pathfinding 1
scoreboard players set mod_mountain pathfinding 16
scoreboard players operation @s pathfinding %= mod_mountain pathfinding

### Remove previous Marker
tp @e[type=piki:move_marker,family=marker_mountain_trader] ~ 3 ~
event entity @e[type=piki:move_marker,family=marker_mountain_trader] instant_despawn



##### ----- MOVE TO CASTLE LOGIC ----- ####

### Move Castle
execute @s[scores={pathfinding=0}] ~ ~ ~ summon piki:move_marker 182 102 -22 marker_mountain_trader
execute @s[scores={pathfinding=1}] ~ ~ ~ summon piki:move_marker 137 85 -18 marker_mountain_trader
execute @s[scores={pathfinding=2}] ~ ~ ~ summon piki:move_marker 67 76 0 marker_mountain_trader
execute @s[scores={pathfinding=3}] ~ ~ ~ summon piki:move_marker 26 78.8 0 marker_mountain_trader



##### ----- GATE LOGIC ----- ####

### Wait at gate
execute @s[scores={pathfinding=4},tag=lowered] ~ ~ ~ tag @s add wait_gate
execute @s[scores={pathfinding=4},tag=lowered] ~ ~ ~ event entity @s wait_gate

### Open gate
execute @s[scores={pathfinding=4},tag=lowered,tag=passcode_known] ~ ~ ~ event entity @e[type=piki:gear,c=1] raise_temp

### Gate already open
execute @s[scores={pathfinding=4},tag=!lowered] ~ ~ ~ scoreboard players add @s pathfinding 1



##### ----- CASTLE LOGIC ----- ####

### Set marker inside castle
execute @s[scores={pathfinding=5}] ~ ~ ~ tag @s remove wait_gate
execute @s[scores={pathfinding=5}] ~ ~ ~ tag @s remove lowered
execute @s[scores={pathfinding=5}] ~ ~ ~ summon piki:move_marker 11 78.8 0 marker_mountain_trader

### Wait at castle on regular runs (skip next pathfinding logic (scores=7) for scared Trader)
execute @s[scores={pathfinding=6},tag=!scared] ~ ~ ~ event entity @s wait_castle
execute @s[scores={pathfinding=6},tag=!scared] ~ ~ ~ scoreboard players add @s pathfinding 1

### Wait in castle on first run (Scared - needs to receive Cyber fox to continue)
execute @s[scores={pathfinding=6},tag=scared] ~ ~ ~ summon piki:move_marker 3 78.8 6 marker_mountain_trader
execute @s[scores={pathfinding=6},tag=scared] ~ ~ ~ event entity @e[type=piki:koop,tag=lowered] raise

### Setup for scared 
execute @s[scores={pathfinding=7},tag=scared] ~ ~ ~ event entity @s sign_warn
execute @s[scores={pathfinding=7},tag=scared] ~ ~ ~ event entity @s wait_castle_scared

### Leave Castle
execute @s[scores={pathfinding=8},tag=scared] ~ ~ ~ event entity @s sign_clear
execute @s[scores={pathfinding=8},tag=scared] ~ ~ ~ tag @s remove scared
execute @s[scores={pathfinding=8}] ~ ~ ~ summon piki:move_marker 3 78.8 0 marker_mountain_trader
execute @s[scores={pathfinding=9}] ~ ~ ~ summon piki:move_marker 22 78.8 0 marker_mountain_trader



##### ----- GATE LOGIC ----- ####

### Wait at gate
execute @s[scores={pathfinding=10},tag=lowered] ~ ~ ~ tag @s add wait_gate

### Gate already open
execute @s[scores={pathfinding=10},tag=!lowered] ~ ~ ~ scoreboard players add @s pathfinding 1



##### ----- MOVE TO VILLAGE LOGIC ----- ####

### Move to Village
execute @s[scores={pathfinding=11}] ~ ~ ~ summon piki:move_marker 67 77.8 0 marker_mountain_trader
execute @s[scores={pathfinding=12}] ~ ~ ~ summon piki:move_marker 137 86.8 -18 marker_mountain_trader
execute @s[scores={pathfinding=13}] ~ ~ ~ summon piki:move_marker 182 103.8 -22 marker_mountain_trader
execute @s[scores={pathfinding=14}] ~ ~ ~ summon piki:move_marker 211 107.8 -25 marker_mountain_trader

### Wait at village
execute @s[scores={pathfinding=15}] ~ ~ ~ event entity @s wait_village



##### ----- CLEANUP ----- ####

### Reset pathing increment
event entity @s increment_reset