### Set player season score
scoreboard players set main season 4
scoreboard players operation @a season = main season

### Set player phase score
scoreboard players set main phase 1
scoreboard players operation @a phase = main phase

### Setup time
time set 0
gamerule dodaylightcycle true
scoreboard players set @a[tag=main] time 1
scoreboard players set world time 1

### First wave starts at sundown on the first day
scoreboard players set @a[tag=main] wave 13000

### Load achievements
event entity @e[type=piki:achievements] week_4
function achievements/update

# Load lecterns
structure load lect_fox_4 -3 85 -7
structure load lect_trap_4 3 85 -7
structure load lect_build -3 85 7
structure load lect_ach 3 85 7

### Load trader
kill @e[type=piki:castle_trader]
execute @a[tag=main,scores={castle_type=1}] ~ ~ ~ structure load trader_b_4 -6 77 -6
execute @a[tag=main,scores={castle_type=2}] ~ ~ ~ structure load trader_d_4 -6 77 -6
execute @a[tag=main,scores={castle_type=3}] ~ ~ ~ structure load trader_f_4 -6 77 -6
execute @a[tag=main,scores={castle_type=4}] ~ ~ ~ structure load trader_m_4 -6 77 -6

### Update dialogue
event entity @e[family=npc] clear
dialogue change @e[type=piki:castle_librarian] librarian_info_season4_1.1
dialogue change @e[type=piki:farmer_beach] farmer_beach_village_4.1
dialogue change @e[type=piki:farmer_desert] farmer_desert_village_4.1
dialogue change @e[type=piki:farmer_forest] farmer_forest_village_4.1
dialogue change @e[type=piki:farmer_mountain] farmer_mountain_village_4.1

execute @e[type=piki:castle_librarian] ~ ~ ~ event entity @e[type=piki:move_marker,family=marker_librarian] instant_despawn
execute @e[type=piki:castle_librarian] ~ ~ ~ tp @s -6 85 -1
execute @e[type=piki:castle_librarian] ~ ~ ~ event entity @s waypoint_pause
execute @e[type=piki:castle_librarian] ~ ~ ~ event entity @s sign_info
execute @e[type=piki:castle_librarian] ~ ~ ~ scoreboard players set @s pathfinding 39

### Remove season changer
fill 6 85 6 6 86 6 air

### Set checking for Malware ach
setblock 5 5 -4 minecraft:redstone_block

### Set checking for Golden Chicken purchase
setblock 5 5 -5 minecraft:redstone_block

### Title display
title @a title §3Season 4
title @a subtitle §bWho can you trust?
stopsound @a piki.season3
playsound piki.season4 @a ~ ~ ~ 0.15

### Set gears if not fixed in Season 3.2
execute @e[type=piki:gear,tag=!uncompromised] ~ ~ ~ tag @s add compromised

### Setup Passcode
event entity @e[type=piki:scanner] activate
event entity @e[type=piki:achievements,family=season_3] a_1
scoreboard players set a9 achievements 3

### Move preloaded hut to village
tp @e[type=piki:farmer_beach,tag=preload] -191 59.8 -11
execute @e[type=piki:farmer_beach,tag=preload] ~ ~ ~ function villages/beach/load_village
scoreboard players set @e[type=piki:farmer_beach,tag=preload] pathfinding 9
tp @e[type=piki:farmer_desert,tag=preload] -1 79 -109
execute @e[type=piki:farmer_desert,tag=preload] ~ ~ ~ function villages/desert/load_village
scoreboard players set @e[type=piki:farmer_desert,tag=preload] pathfinding 10
tp @e[type=piki:farmer_forest,tag=preload] 51 87.8 140
execute @e[type=piki:farmer_forest,tag=preload] ~ ~ ~ function villages/forest/load_village
scoreboard players set @e[type=piki:farmer_forest,tag=preload] pathfinding 9
tp @e[type=piki:farmer_mountain,tag=preload] 166 118.8 20
execute @e[type=piki:farmer_mountain,tag=preload] ~ ~ ~ function villages/mountain/load_village
scoreboard players set @e[type=piki:farmer_mountain,tag=preload] pathfinding 12
event entity @e[tag=preload] continue

execute @a[tag=main,tag=!hut_beach] ~ ~ ~ tp @e[type=piki:farmer_beach] -32 77 0
execute @a[tag=main,tag=!hut_beach] ~ ~ ~ scoreboard players set @e[type=piki:farmer_beach] pathfinding 2
execute @a[tag=main,tag=!hut_desert] ~ ~ ~ tp @e[type=piki:farmer_desert] 0 77 -32
execute @a[tag=main,tag=!hut_desert] ~ ~ ~ scoreboard players set @e[type=piki:farmer_desert] pathfinding 4
execute @a[tag=main,tag=!hut_forest] ~ ~ ~ tp @e[type=piki:farmer_forest] 0 77 32
execute @a[tag=main,tag=!hut_forest] ~ ~ ~ scoreboard players set @e[type=piki:farmer_forest] pathfinding 1
execute @a[tag=main,tag=!hut_mountain] ~ ~ ~ tp @e[type=piki:farmer_mountain] 32 77 0
execute @a[tag=main,tag=!hut_mountain] ~ ~ ~ scoreboard players set @e[type=piki:farmer_mountain] pathfinding 2

execute @a[tag=main,tag=!hut_beach] ~ ~ ~ event entity @e[type=piki:farmer_beach] continue
execute @a[tag=main,tag=!hut_desert] ~ ~ ~ event entity @e[type=piki:farmer_desert] continue
execute @a[tag=main,tag=!hut_forest] ~ ~ ~ event entity @e[type=piki:farmer_forest] continue
execute @a[tag=main,tag=!hut_mountain] ~ ~ ~ event entity @e[type=piki:farmer_mountain] continue

event entity @e[type=piki:gear,family=!gear_complete] setup

### Load players
tp @a 3 85 0 90 0

### Clear barrier blocks in Library
fill -8 83 9 -4 88 -8 air 0 replace minecraft:barrier