event entity @e[family=!player] instant_despawn
kill @e[family=!player]
scoreboard players reset @a temp

### Setup utilities
scoreboard objectives remove temp
scoreboard objectives add temp dummy
scoreboard objectives remove gameplay
scoreboard objectives add gameplay dummy
scoreboard objectives remove setup_npc_diag
scoreboard objectives add setup_npc_diag dummy
scoreboard objectives remove village_picker
scoreboard objectives add village_picker dummy
scoreboard objectives remove farmer_picker
scoreboard objectives add farmer_picker dummy
scoreboard objectives remove feed
scoreboard objectives add feed dummy
scoreboard objectives remove passcode
scoreboard objectives add passcode dummy
scoreboard objectives remove award
scoreboard objectives add award dummy
scoreboard objectives remove trader_fox
scoreboard objectives add trader_fox dummy
scoreboard objectives remove pathfinding
scoreboard objectives add pathfinding dummy
scoreboard objectives remove season_code
scoreboard objectives add season_code dummy

### achievements
scoreboard objectives remove achievements
scoreboard objectives add achievements dummy

### Setup castle
scoreboard objectives remove castle_type
scoreboard objectives add castle_type dummy
scoreboard objectives remove castle_level
scoreboard objectives add castle_level dummy

### Setup time
scoreboard objectives remove time
scoreboard objectives add time dummy
time set 0
gamerule dodaylightcycle false

### Setup seasons
scoreboard objectives remove season
scoreboard objectives add season dummy
scoreboard players set @a season 0

### Setup waves
scoreboard objectives remove wave
scoreboard objectives add wave dummy

### Setup phases
scoreboard objectives remove phase
scoreboard objectives add phase dummy

### Setup raids
scoreboard objectives remove raid
scoreboard objectives add raid dummy
scoreboard objectives remove raid_logic
scoreboard objectives add raid_logic dummy

scoreboard objectives remove trap_test
scoreboard objectives add trap_test dummy

### Load in Castle Librarian
summon piki:castle_librarian -7 85 -2
execute @e[type=piki:castle_librarian] ~0.5 ~ ~ tp ~ ~ ~ -90 0 
event entity @e[type=piki:castle_librarian] sign_info
scoreboard players add @e[type=piki:castle_librarian] pathfinding -1

### Setup ticking areas
tickingarea add 0 0 0 159 254 159 q1
tickingarea add -160 0 0 -1 254 159 q2
tickingarea add -160 0 -160 -1 254 -1 q3
tickingarea add 0 0 -160 159 254 -1 q4
tickingarea add -50 0 160 50 254 230 q5
tickingarea add -230 0 -50 -161 254 50 q6
tickingarea add -50 0 -230 50 254 -161 q7
tickingarea add 160 0 -50 230 254 50 q8

### Load block to stairs
fill -6 85 8 -5 86 8 minecraft:barrier
fill -8 86 5 -8 87 6 minecraft:barrier
fill -6 85 -8 -5 86 -8 minecraft:barrier
fill -8 86 -5 -8 87 -6 minecraft:barrier

### Load in players
tp @a 3 85 0 90 0
setworldspawn 3 85 0
clear @a
gamerule sendcommandfeedback false

### Initialise achievements
function achievements/init

### Load achievement boards
event entity @e[type=piki:achievements] instant_despawn
summon piki:achievements 6 85.35 -7.8 season_1
summon piki:achievements 8.8 85.35 -6 season_2
summon piki:achievements 8.8 85.35 6 season_3
summon piki:achievements 6 85.35 8.8 season_4
summon piki:board 7.99 85.075 0 awards
event entity @e[type=piki:achievements] week_1

### Load in initial castle
# function castle/mountain_s

### Load in castle selectors
summon piki:castle -6.8 86 1.1 beach
summon piki:castle -6.8 87.1 1.1 desert
summon piki:castle -6.8 86 -0.1 forest
summon piki:castle -6.8 87.1 -0.1 mountain
event entity @e[type=piki:castle,family=mountain] select

### Init Passcode temps
scoreboard players add p1 temp 0
scoreboard players add p2 temp 0
scoreboard players add p3 temp 0

summon piki:banner -6.48 88.15 0 banner_0
tag @e[type=piki:banner] add castle
summon piki:banner 0 88.15 -6.48 banner_1
summon piki:banner 0 88.15 7.48 banner_2

summon piki:rewards 0 85 7

### Load in Virtual Castle
summon piki:virtual_castle 0 89.5 0

### Clear Scanner Wall
fill 4 81 2 4 83 2 air

### Load in castle mechanics
structure load castle_mech_updated -1 4 -6

### Load in achievements
summon piki:board 0.5 85.075 -6.92 map

### Unload any leftover structures
function villages/unload_all_huts
function villages/unload_all_villages

effect @a instant_health 1 254
effect @a saturation 1 254

### Turn PVP off
gamerule pvp false
gamerule dodaylightcycle false
gamerule commandblockoutput false

tag @a remove init
tag @a remove init_fix
tag @a remove main
tag @a remove start
tag @a remove malware
tag @a remove malware_detect
tag @a remove malware_run
tag @a remove ach_14
tag @a remove no_ach_14
tag @a remove check_ach_14
tag @a remove hut_beach
tag @a remove hut_desert
tag @a remove hut_forest
tag @a remove hut_mountain
tag @a remove village_beach
tag @a remove village_desert
tag @a remove village_forest
tag @a remove village_mountain
tag @a remove expand_village
tag @a remove trader_fox_loaded
tag @a remove summon_trader_fox
tag @a remove tXR4i8ivsG
tag @a remove PNst51uDa9
tag @a remove 3acqesntuo

### Load Awards
event entity @e[type=piki:award] instant_despawn
summon piki:award -86 60 37 identify
execute @e[type=piki:award,tag=] ~ ~ ~ tp @s ~ ~ ~ 180 0
tag @e[type=piki:award] add loaded
summon piki:award 54 58.5 -200 protect
execute @e[type=piki:award,tag=] ~ ~ ~ tp @s ~ ~ ~ -110 0
tag @e[type=piki:award] add loaded
summon piki:award 149 60 124 detect
execute @e[type=piki:award,tag=] ~ ~ ~ tp @s ~ ~ ~ -30 0
tag @e[type=piki:award] add loaded
setblock 223 131 46 air
summon piki:award 223 131 46 respond
execute @e[type=piki:award,tag=] ~ ~ ~ tp @s ~ ~ ~ -50 0
tag @e[type=piki:award] add loaded
setblock 215 95 -35 air
summon piki:award 215.0 95 -35.0 recover
execute @e[type=piki:award,tag=] ~ ~ ~ tp @s ~ ~ ~ -60 0
tag @e[type=piki:award] add loaded

setblock -36 74 -9 minecraft:dirt
setblock -36 74 9 minecraft:dirt
setblock -9 74 -36 minecraft:dirt
setblock 9 74 -36 minecraft:dirt
setblock -10 74 36 minecraft:dirt
setblock 10 74 36 minecraft:dirt
setblock 36 74 -10 minecraft:dirt
setblock 36 74 10 minecraft:dirt

kill @e[type=piki:emergency]
summon piki:emergency 25 78 -2 east
summon piki:emergency 2 78 25 south
summon piki:emergency -25 78 2 west
summon piki:emergency -2 78 -25 north

### Load broken walls
function gameplay/setup/walls
execute @e[type=piki:waller] ~ ~ ~ function gameplay/castle/destroy_wall

### Setup gear
event entity @e[type=piki:gear] instant_despawn
summon piki:gear 0 84 -22.4 north
tag @e[type=piki:gear,tag=] add north
execute @e[type=piki:gear,tag=north] ~ ~ ~ tp @s ~ ~ ~ 0 0
summon piki:gear 23.4 84 0 east
tag @e[type=piki:gear,tag=] add east
execute @e[type=piki:gear,tag=east] ~ ~ ~ tp @s ~ ~ ~ 90 0
summon piki:gear 0 84 23.4 south
tag @e[type=piki:gear,tag=] add south
execute @e[type=piki:gear,tag=south] ~ ~ ~ tp @s ~ ~ ~ 180 0
summon piki:gear -22.4 84 0 west
tag @e[type=piki:gear,tag=] add west
execute @e[type=piki:gear,tag=west] ~ ~ ~ tp @s ~ ~ ~ -90 0

### Reset border blocks at gates
execute @e[type=piki:gear,tag=north] ~ ~ ~ fill ~-1 -60 ~ ~1 -60 ~ stone 0
execute @e[type=piki:gear,tag=east] ~ ~ ~ fill ~ -60 ~-1 ~ -60 ~1 stone 0
execute @e[type=piki:gear,tag=south] ~ ~ ~ fill ~-1 -60 ~ ~1 -60 ~ stone 0
execute @e[type=piki:gear,tag=west] ~ ~ ~ fill ~ -60 ~-1 ~ -60 ~1 stone 0

kill @e[type=item,name=lead]